export interface ReferenceOptions {
    digest?: string;
    type?: ReferenceType;
    domain?: string;
    repository?: string;
    tag?: string;
}
declare const typesTemplates: {
    digest: (ref: Reference) => string;
    canonical: (ref: Reference) => string;
    repository: (ref: Reference) => string;
    tagged: (ref: Reference) => string;
    dual: (ref: Reference) => string;
};
export type ReferenceType = keyof typeof typesTemplates;
export declare class Reference {
    get tag(): string | undefined;
    get digest(): string | undefined;
    get repository(): string | undefined;
    get domain(): string | undefined;
    get type(): ReferenceType;
    private readonly _domain;
    private readonly _repository;
    private readonly _digest;
    private readonly _type;
    private readonly _tag;
    constructor(options: ReferenceOptions);
    toString(): string;
    get repositoryUrl(): string;
}
export {};
